  /*  menu.c - powershell
   *  Copyright (C) 1999  Matt Spong <spong@glue.umd.edu>
   *  Based from zterm.c by Michael Zucci from the libzvt docs
   *
   *  A big, puffy lotsa-shells-in-one app. 
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "powershell.h"

GtkItemFactoryEntry menu_items_tmp[] = {

  { "/File/sep1", NULL, NULL, 0, "<Separator>"},
  { "/File/_Quit", NULL, MenuHandler, 99, NULL},
  
  { "/_Edit", NULL, NULL, 0, "<Branch>" },
  { "/Edit/Cu_t", NULL, MenuHandler, 101, NULL},
  { "/Edit/_Copy", NULL, MenuHandler, 102, NULL},
  { "/Edit/_Paste", NULL, MenuHandler, 103, NULL},
  { "/Edit/sep1", NULL, NULL, 0, "<Separator>"},
  { "/Edit/Pre_ferences...", NULL, MenuHandler, 104, NULL},

  { "/_Tab", NULL, NULL, 0, "<Branch>" },
  { "/Tab/Rename Current Tab", NULL, MenuHandler, 210, NULL},
  { "/Tab/Switch to tab _1", "<control>1", MenuHandler, 201, NULL},
  { "/Tab/Switch to tab _2", "<control>2", MenuHandler, 202, NULL},
  { "/Tab/Switch to tab _3", "<control>3", MenuHandler, 203, NULL},
  { "/Tab/Switch to tab _4", "<control>4", MenuHandler, 204, NULL},
  { "/Tab/Switch to tab _5", "<control>5", MenuHandler, 205, NULL},
  { "/Tab/Switch to tab _6", "<control>6", MenuHandler, 206, NULL},
  { "/Tab/Switch to tab _7", "<control>7", MenuHandler, 207, NULL},
  { "/Tab/Switch to tab _8", "<control>8", MenuHandler, 208, NULL},
  { "/Tab/Switch to tab _9", "<control>9", MenuHandler, 209, NULL},

  { "/_Help", NULL, NULL, 0, "<Branch>" },
  { "/Help/About", NULL, MenuHandler, 1001, NULL }

};  

void get_main_menu (GtkWidget * window, GtkWidget **menubar)
{
  GtkItemFactory *item_factory;
  GtkAccelGroup *accel_group;
  GtkItemFactoryEntry * cm;
  int a;

  gint nmenu_items2 = sizeof (menu_items_tmp) / sizeof (menu_items_tmp[0]);
  gint nmenu_items = num_apps+1;

  cm = (GtkItemFactoryEntry *)malloc (sizeof(menu_items_tmp[0]) * 
				      (nmenu_items + nmenu_items2));
  
  for (a=0;a<nmenu_items+nmenu_items2;a++)
    {
      if (a < nmenu_items)
	memcpy (&(cm[a]), &(menu_items[a]), sizeof(menu_items_tmp[0]));
      else
	memcpy (&(cm[a]), &(menu_items_tmp[a-nmenu_items]), sizeof(menu_items_tmp[0]));
    }

  accel_group = gtk_accel_group_new ();
  
  item_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>", 
				       accel_group);
  
  gtk_item_factory_create_items (item_factory, nmenu_items+nmenu_items2, cm, NULL);
  
  gtk_window_add_accel_group (GTK_WINDOW (window), accel_group);
  
  if (menubar)
    *menubar = gtk_item_factory_get_widget (item_factory, "<main>");
}

GtkItemFactoryEntry * menu_items;

int InitMenus (GtkWidget * window)
{
  int a;
  GtkWidget * menubar;


  menu_items = (GtkItemFactoryEntry *)malloc (sizeof (GtkItemFactoryEntry) * (num_apps+1));
 
  menu_items[0].path = (char *)malloc (7);
  strcpy (menu_items[0].path, "/_File");

  menu_items[0].accelerator = NULL;
  menu_items[0].callback = NULL;
  menu_items[0].callback_action = 0;
  
  menu_items[0].item_type = (char *)malloc (9);
  strcpy (menu_items[0].item_type, "<Branch>");

  for (a=1;a<=num_apps;a++)
    {

      menu_items[a].path = (char *)malloc (strlen(app_entries[a-1].menu_item_title)+7);
      sprintf (menu_items[a].path, "/File/%s", app_entries[a-1].menu_item_title);

      menu_items[a].accelerator = NULL;
      menu_items[a].callback = MenuHandler;
      menu_items[a].callback_action = a;
      menu_items[a].item_type = NULL;
    }

  get_main_menu (window, &menubar);
  
  gtk_box_pack_start (GTK_BOX(window), menubar, FALSE, FALSE, 0);
  gtk_widget_show (menubar);

}


